<html><head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    <title>imnoise</title>
    <style type="text/css" media="all">
      @import url("scilab_code.css");
      @import url("xml_code.css");
      @import url("c_code.css");
      @import url("style.css");
    </style>
  </head>
  <body>
    <div class="manualnavbar">
    <table width="100%"><tr>
      <td width="30%">
    	<span class="previous"><a href="immedian.html">&lt;&lt; immedian</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_66be415d912567cd351e37e73bc467f0.html">Image Enhancement and Restoration</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="imwiener2.html">imwiener2 &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>



    <span class="path"><a href="index.html">IPCV - Image Processing and Computer Vision Toolbox for Scilab</a> &gt;&gt; <a href="section_66be415d912567cd351e37e73bc467f0.html">Image Enhancement and Restoration</a> &gt; imnoise</span>

    <br /><br />
    <div class="refnamediv"><h1 class="refname">imnoise</h1>
    <p class="refpurpose">Add noise (gaussian, etc.) to an image</p></div>


<div class="refsynopsisdiv"><h3 class="title">Syntax</h3>
   <div class="synopsis"><pre><span class="default">imn</span><span class="default"> = </span><span class="functionid">imnoise</span><span class="default">(</span><span class="default">im</span><span class="default">, </span><span class="default">type</span><span class="default"> [,</span><span class="default">parameters</span><span class="default">])</span></pre></div></div>

<div class="refsection"><h3 class="title">Parameters</h3>
   <dl><dt><span class="term">im :</span>
      <dd><p class="para">Input image.</p></dd></dt>
   <dt><span class="term">type :</span>
      <dd><p class="para">String having one of these values:</p></dd></dt>
   <dt><span class="term">&#0039;salt &amp; pepper&#0039; :</span>
      <dd><p class="para">drop-out/On-off noise</p></dd></dt>
   <dt><span class="term">&#0039;speckle&#0039; :</span>
      <dd><p class="para">multiplicative noise</p></dd></dt>
   <dt><span class="term">&#0039;gaussian&#0039; :</span>
      <dd><p class="para">Gaussian white/additive noise</p></dd></dt>
   <dt><span class="term">&#0039;localvar&#0039; :</span>
      <dd><p class="para">Pixel-specific variance (Zero-mean Gaussian)</p></dd></dt>
   <dt><span class="term">&#0039;poisson&#0039; :</span>
      <dd><p class="para">Not yet implemented</p></dd></dt>
   <dt><span class="term">parameters :</span>
      <dd><p class="para">A sequence of parameters to control the noise distribution, depending on the chosen type. If omitted, default values are used (see below).</p></dd></dt>
   <dt><span class="term">imn :</span>
      <dd><p class="para">Noisy image, which has the same size and type as input image im .</p></dd></dt></dl></div>

<div class="refsection"><h3 class="title">Description</h3>
   <p class="para">imnoise(im, type [, parameters]) adds a type of noise to the intensity image im. Optionally, you can control the noise parameters starting at the 3rd. Argument to imnoise. Here are example of noise types and their parameterss:</p>
   <p class="para">imn = imnoise(im,&#0039;salt &amp; pepper&#0039;,d) adds drop-out noise, where d is the noise density (probability of swapping a pixel). (default: d=0.05).</p>
   <p class="para">imn = imnoise(im,&#0039;gaussian&#0039;,m,v) adds Gaussian additive noise of mean m and variance v. (default: m=0 and v=0.01)</p>
   <p class="para">im = imnoise(im,&#0039;localvar&#0039;,V) additive zero-mean Gaussian noise where the variance at im(i,j) is V(i,j).</p>
   <p class="para">imn = imnoise(im,&#0039;localvar&#0039;, intensity, V) additive zero-mean Gaussian noise, and the local variance of the noise, var, is a function of the image intensity values in im. The variance is matrix( interp1(intensity(:),V(:),im(:)), size(im) )</p>
   <p class="para">imn = imnoise(im,&#0039;speckle&#0039;,v) adds multiplicative noise, using imn = im + noise*im, where noise is uniformly distributed with mean 0 and variance v. (default: v=0.04)</p>
   <p class="para">By default, we consider that &#0034;1&#0034; corresponds to the maximum intensity value of the image, and &#0034;0&#0034; to minimum. If the input image im is an integer image, it will be converted to double using im2double function first. Before return the result, the image will be converted to the same type as the input image. The elements in the output matrix imn that exceed the range of the integer or double type will be truncated.</p>
   <p class="para">Supported classes: INT8, UINT8, INT16, UINT16, INT32, DOUBLE.</p>
   <p class="para"></p></div>

<div class="refsection"><h3 class="title">Examples</h3>
   <div class="programlisting"><table border="0" width="100%"><tr><td width="98%"><pre class="scilabcode"><span class="scilabid">im</span> <span class="scilaboperator">=</span> <span class="scilabid">imread</span><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://fullpath">fullpath</a><span class="scilabopenclose">(</span><span class="scilabid">getIPCVpath</span><span class="scilabopenclose">(</span><span class="scilabopenclose">)</span> <span class="scilaboperator">+</span> <span class="scilabstring">&#0034;</span><span class="scilabstring">/images/</span><span class="scilabstring">&#0034;</span> <span class="scilaboperator">+</span> <span class="scilabstring">&#0039;</span><span class="scilabstring">baboon.png</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabid">imn</span> <span class="scilaboperator">=</span> <span class="scilabid">imnoise</span><span class="scilabopenclose">(</span><span class="scilabid">im</span><span class="scilabdefault">,</span> <span class="scilabstring">&#0039;</span><span class="scilabstring">gaussian</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">imshow</span><span class="scilabopenclose">(</span><span class="scilabid">imn</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabid">imn</span> <span class="scilaboperator">=</span> <span class="scilabid">imnoise</span><span class="scilabopenclose">(</span><span class="scilabid">im</span><span class="scilabdefault">,</span> <span class="scilabstring">&#0039;</span><span class="scilabstring">salt </span><span class="scilabstring">&#0038;</span><span class="scilabstring"> pepper</span><span class="scilabstring">&#0039;</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">imshow</span><span class="scilabopenclose">(</span><span class="scilabid">imn</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabid">imn</span> <span class="scilaboperator">=</span> <span class="scilabid">imnoise</span><span class="scilabopenclose">(</span><span class="scilabid">im</span><span class="scilabopenclose">(</span><span class="scilabspecial">:</span><span class="scilabdefault">,</span><span class="scilabspecial">:</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span> <span class="scilabstring">&#0039;</span><span class="scilabstring">salt </span><span class="scilabstring">&#0038;</span><span class="scilabstring"> pepper</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span> <span class="scilabnumber">0.2</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">imshow</span><span class="scilabopenclose">(</span><span class="scilabid">imn</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabid">lowtri</span> <span class="scilaboperator">=</span> <a class="scilabcommand" href="scilab://tril">tril</a><span class="scilabopenclose">(</span><a class="scilabcommand" href="scilab://ones">ones</a><span class="scilabopenclose">(</span><span class="scilabid">im</span><span class="scilabopenclose">(</span><span class="scilabspecial">:</span><span class="scilabdefault">,</span><span class="scilabspecial">:</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">imn</span> <span class="scilaboperator">=</span> <span class="scilabid">imnoise</span><span class="scilabopenclose">(</span> <span class="scilabid">im</span><span class="scilabopenclose">(</span><span class="scilabspecial">:</span><span class="scilabdefault">,</span><span class="scilabspecial">:</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span> <span class="scilabstring">&#0039;</span><span class="scilabstring">localvar</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span> <span class="scilabid">lowtri</span><span class="scilaboperator">/</span><span class="scilabnumber">5</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">imshow</span><span class="scilabopenclose">(</span><span class="scilabid">imn</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabid">imn</span> <span class="scilaboperator">=</span> <span class="scilabid">imnoise</span><span class="scilabopenclose">(</span> <span class="scilabid">im</span><span class="scilabopenclose">(</span><span class="scilabspecial">:</span><span class="scilabdefault">,</span><span class="scilabspecial">:</span><span class="scilabdefault">,</span><span class="scilabnumber">1</span><span class="scilabopenclose">)</span><span class="scilabdefault">,</span> <span class="scilabstring">&#0039;</span><span class="scilabstring">localvar</span><span class="scilabstring">&#0039;</span><span class="scilabdefault">,</span> <span class="scilabopenclose">[</span><span class="scilabnumber">0</span><span class="scilabspecial">:</span><span class="scilabnumber">0.1</span><span class="scilabspecial">:</span><span class="scilabnumber">1</span><span class="scilabopenclose">]</span><span class="scilabdefault">,</span> <span class="scilabopenclose">[</span><span class="scilabnumber">0</span><span class="scilabspecial">:</span><span class="scilabnumber">0.1</span><span class="scilabspecial">:</span><span class="scilabnumber">1</span><span class="scilabopenclose">]</span><span class="scilaboperator">.^</span><span class="scilabnumber">3</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">imshow</span><span class="scilabopenclose">(</span><span class="scilabid">imn</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span>

<span class="scilabid">imn</span> <span class="scilaboperator">=</span> <span class="scilabid">imnoise</span><span class="scilabopenclose">(</span><span class="scilabid">im</span><span class="scilabdefault">,</span> <span class="scilabstring">&#0039;</span><span class="scilabstring">speckle</span><span class="scilabstring">&#0039;</span> <span class="scilabopenclose">)</span><span class="scilabdefault">;</span>
<span class="scilabid">imshow</span><span class="scilabopenclose">(</span><span class="scilabid">imn</span><span class="scilabopenclose">)</span><span class="scilabdefault">;</span></pre></td><td valign="top"><a href="scilab://scilab.execexample/"><img src="ScilabExecute.png" border="0"/></a></td><td valign="top"><a href="scilab://scilab.editexample/"><img src="ScilabEdit.png" border="0"/></a></td><td></td></tr></table></div></div>

<div class="refsection"><h3 class="title">See also</h3>
   <ul class="itemizedlist"><li class="member"><a href="imfilter.html" class="link">imfilter</a></li></ul></div>

<div class="refsection"><h3 class="title">Authors</h3>
   <ul class="itemizedlist"><li class="member">Shiqi Yu</li>
   <li class="member">Ricardo Fabbri</li>
   <li class="member">Tan Chin Luh</li></ul></div>
    <br />

    <div class="manualnavbar">
    <table width="100%">
    <tr><td colspan="3" class="next"><a href="http://bugzilla.scilab.org/enter_bug.cgi?product=Scilab%20software&component=Documentation%20pages" class="ulink">Report an issue</a></td></tr>
<tr>
      <td width="30%">
    	<span class="previous"><a href="immedian.html">&lt;&lt; immedian</a></span>

      </td>
      <td width="40%" class="center">
      	<span class="top"><a href="section_66be415d912567cd351e37e73bc467f0.html">Image Enhancement and Restoration</a></span>

      </td>
      <td width="30%" class="next">
      	<span class="next"><a href="imwiener2.html">imwiener2 &gt;&gt;</a></span>

      </td>
    </tr></table>
      <hr />
    </div>
  </body>
</html>
